# Contributing to HTML Inspector

Pull requests are greatly appreciated and encouraged. If you want to get your pull request accepted, please make sure it meets a few minimum requirements:

- **Test files are required**
  If you're adding a new rule or module you must add a corresponding test. Check out how the built-in rules are tested for examples.

- **Your changes must pass JSHint**
  You can run JSHint from the command line via `grunt jshint`.

- **Follow the existing coding style**
  Consistency is key in any project, so any changes should look like the existing code. At a minimum please do the following: (1) Use two spaces for indentation, and (2) don't use semicolons at the end of lines (I know, I'm crazy, but that's how I like it).

If you'd like to contribute but aren't sure how, take a look at the open issues in the issue tracker. There you'll find bug reports as well as feature requests; feel free to tackle either.